package drzewa;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

/**
 *glowna klasa programu (applet)
 */
public class Drzewa extends Applet implements ActionListener {
    DrzewoAVL drzewo;
    Tramp tramp; // on bedzie wykonywal kroki  :)
    TextField tWstaw;
    Button bWstaw;
    DrzewoAVL dAVL; // tu bedziemy przechowywac wskaznik do miejsca w ktorym
    // trzeba wywolac chkAVL (naciskajac przycisk bAVL).
    Button bAVL; // nacisniecie tego bedzie wywolywalo dAVL.chkAVL()
    // (po wstawieniu nowego elementu)
    
    public void paint(Graphics g) {
        if(drzewo != null) drzewo.paint(g);
    }
    
    public void init() {
        tWstaw = new TextField("",10);
        tWstaw.setSize(40, tWstaw.getSize().height);
        add(tWstaw);
        bWstaw = new Button("Wstaw");
        bWstaw.addActionListener(this);
        add(bWstaw);
        bAVL = new Button("AVL");
        bAVL.setEnabled(false);
        bAVL.addActionListener(this);
        add(bAVL);
        validate();
    }
    public void start() {}
        // tu nie ma {tramp = new Tramp(..); tramp.start();}
        // bo to bedzie zrobione przy pierwszym actionPerformed(..)
    public void stop() {
        if(tramp != null) tramp.stop();
    }
    public void destroy() {}
    
    public boolean mouseDown(Event e,int x,int y) {
        if(drzewo != null) drzewo.setPos(new Point(x,y));
        return true;
    }
    
    public void actionPerformed(ActionEvent e) {
        String s = e.getActionCommand();
        if(s == "Wstaw") {
            try{
                int val = Integer.parseInt(tWstaw.getText());
                if(drzewo == null) {
                    drzewo = new DrzewoAVL(this,val);
                    drzewo.setPos(new Point(100,50));
                    tramp = new Tramp(drzewo,50);
                    tramp.start();
                } else {
                    dAVL = drzewo.wstaw(val);
                    if(dAVL != null) bAVL.setEnabled(true);
                }
            }catch(NumberFormatException ex) {}
        } else if(s == "AVL") {
            if(dAVL != null) dAVL.chkAVL();
            dAVL = null;
            bAVL.setEnabled(false);
        }
    }
}
