package drzewa;
import java.util.*;

/**
 *Klasa wykonujca 'kroki' dla podanego obiektu w podanych odstpach czasowych.
 */
public class Tramp {
    IKrok ikrok;
    int czas;
    Timer timer;
    public Tramp(IKrok aikrok,int aczas) {
        if(aikrok == null) throw new NullPointerException();
        ikrok = aikrok;
        czas = aczas;
    }
    public void start() {
        stop(); // na wszelki wypadek
        timer = new Timer();
        timer.schedule(new ATask(),0,czas);
    }
    public void stop() {
        if(timer != null) timer.cancel();
        timer = null;
    }
    class ATask extends TimerTask {
        public void run() { ikrok.krok(); }
    }
}
